diff --git a/doc/guides/rel_notes/release_19_11.rst b/doc/guides/rel_notes/release_19_11.rst
index 48c80e5..0a24c25 100644
--- a/doc/guides/rel_notes/release_19_11.rst
+++ b/doc/guides/rel_notes/release_19_11.rst
@@ -56,57 +56,59 @@ New Features
      Also, make sure to start the actual text at the margin.
      =========================================================
 
-* **FreeBSD now supports `--base-virtaddr` EAL option.**
+* **Added support for --base-virtaddr EAL option to FreeBSD.**
 
-  FreeBSD version now also supports setting base virtual address for mapping
-  pages and resources into its address space.
+  The FreeBSD version of DPDK now also supports setting base virtual address
+  for mapping pages and resources into its address space.
 
 * **Added Lock-free Stack for aarch64.**
 
-  The lock-free stack implementation is enabled for aarch64 platforms.
+  Enabled the lock-free stack implementation for aarch64 platforms.
 
-* **Changed mempool allocation behaviour.**
+* **Changed mempool allocation behavior.**
 
-  Objects are no longer across pages by default.
-  It may consume more memory when using small memory pages.
+  Changed the mempool allocation behaviour so that objects no longer cross
+  pages by default. Note, this may consume more memory when using small memory
+  pages.
 
-* **Added support of dynamic fields and flags in mbuf.**
+* **Added support for dynamic fields and flags in mbuf.**
 
   This new feature adds the ability to dynamically register some room
   for a field or a flag in the mbuf structure. This is typically used
   for specific offload features, where adding a static field or flag
   in the mbuf is not justified.
 
-* **Added hairpin queue.**
+* **Added support for hairpin queues.**
 
-  On supported NICs, we can now setup haipin queue which will offload packets
-  from the wire, backto the wire.
+  On supported NICs, we can now setup hairpin queues which will offload packets
+  from the wire, back to the wire.
 
 * **Added flow tag in rte_flow.**
 
-  SET_TAG action and TAG item have been added to support transient flow tag.
+  The ``SET_TAG`` action and ``TAG`` item have been added to support transient
+  flow tag.
 
 * **Extended metadata support in rte_flow.**
 
-  Flow metadata is extended to both Rx and Tx.
+  Flow metadata has been extended to both Rx and Tx.
 
   * Tx metadata can also be set by SET_META action of rte_flow.
-  * Rx metadata is delivered to host via a dynamic field of ``rte_mbuf`` with
-    PKT_RX_DYNF_METADATA.
+  * Rx metadata is delivered to the host via a dynamic field of ``rte_mbuf``
+    with ``PKT_RX_DYNF_METADATA``.
 
-* **Added ethdev API to set supported packet types**
+* **Added ethdev API to set supported packet types.**
 
-  * Added new API ``rte_eth_dev_set_ptypes`` that allows an application to
-    inform PMD about reduced range of packet types to handle.
-  * This scheme will allow PMDs to avoid lookup to internal ptype table on Rx
-    and thereby improve Rx performance if application wishes do so.
+  * Added new API ``rte_eth_dev_set_ptypes`` which allows an application to
+    inform a PMD about a reduced range of packet types to handle.
+  * This scheme will allow PMDs to avoid lookup of internal ptype table on Rx
+    and thereby improve Rx performance if the application wishes to do so.
 
-* **Added Rx offload flag to enable or disable RSS update**
+* **Added Rx offload flag to enable or disable RSS update.**
 
-  * Added new Rx offload flag `DEV_RX_OFFLOAD_RSS_HASH` which can be used to
-    enable/disable PMDs write to `rte_mbuf::hash::rss`.
-  * PMDs notify the validity of `rte_mbuf::hash:rss` to the application
-    by enabling `PKT_RX_RSS_HASH ` flag in `rte_mbuf::ol_flags`.
+  * Added new Rx offload flag ``DEV_RX_OFFLOAD_RSS_HASH`` which can be used to
+    enable/disable PMDs write to ``rte_mbuf::hash::rss``.
+  * PMDs notify the validity of ``rte_mbuf::hash:rss`` to the application
+    by enabling ``PKT_RX_RSS_HASH`` flag in ``rte_mbuf::ol_flags``.
 
 * **Updated the enic driver.**
 
@@ -116,7 +118,7 @@ New Features
 * **Added Hisilicon hns3 PMD.**
 
   Added the new ``hns3`` net driver for the inbuilt Hisilicon Network
-  Subsystem 3(HNS3) network engine found in the Hisilicon Kunpeng 920 SoC.
+  Subsystem 3 (HNS3) network engine found in the Hisilicon Kunpeng 920 SoC.
   See the :doc:`../nics/hns3` guide for more details on this new driver.
 
 * **Added NXP PFE PMD.**
@@ -144,11 +146,11 @@ New Features
 
   Added support for the ``RTE_ETH_DEV_CLOSE_REMOVE`` flag.
 
-* **Added RX/TX packet burst mode get API.**
+* **Added Rx/Tx packet burst mode "get" API.**
 
   Added two new functions ``rte_eth_rx_burst_mode_get`` and
   ``rte_eth_tx_burst_mode_get`` that allow an application
-  to retrieve the mode information about RX/TX packet burst
+  to retrieve the mode information about Rx/Tx packet burst
   such as Scalar or Vector, and Vector technology like AVX2.
 
 * **Updated the Intel ice driver.**
@@ -169,8 +171,9 @@ New Features
 
 * **Added cryptodev asymmetric session-less operation.**
 
-  Added session-less option to cryptodev asymmetric structure. It works the same
-  way as symmetric crypto, corresponding xform is used directly by the crypto op.
+  Added a session-less option to the cryptodev asymmetric structure. It works
+  the same way as symmetric crypto, and the corresponding transform is used
+  directly by the crypto operation.
 
 * **Updated the Huawei hinic driver.**
 
@@ -199,29 +202,31 @@ New Features
   Updated the AF_XDP PMD. The new features include:
 
   * Enabled zero copy between application mempools and UMEM by enabling the
-    XDP_UMEM_UNALIGNED_CHUNKS UMEM flag.
+    ``XDP_UMEM_UNALIGNED_CHUNKS UMEM`` flag.
 
 * **Added Marvell NITROX symmetric crypto PMD.**
 
   Added a symmetric crypto PMD for Marvell NITROX V security processor.
-  See the :doc:`../cryptodevs/nitrox` guide for more details on this new
+  See the :doc:`../cryptodevs/nitrox` guide for more details on this new PMD.
 
 * **Added asymmetric support to Marvell OCTEON TX crypto PMD.**
 
-  Added support for asymmetric operations in Marvell OCTEON TX cypto PMD.
+  Added support for asymmetric operations to Marvell OCTEON TX crypto PMD.
   Supports RSA and modexp operations.
 
-* **Added Marvell OCTEON TX2 crypto PMD**
+* **Added Marvell OCTEON TX2 crypto PMD.**
 
-  Added a new PMD driver for h/w crypto offload block on ``OCTEON TX2`` SoC.
+  Added a new PMD driver for hardware crypto offload block on ``OCTEON TX2``
+  SoC.
 
   See :doc:`../cryptodevs/octeontx2` for more details
 
 * **Updated NXP crypto PMDs for PDCP support.**
 
-  PDCP support is added to DPAA_SEC and DPAA2_SEC PMDs using rte_security APIs.
-  Support is added for all sequence number sizes for control and user plane.
-  Test and test-crypto-perf applications are updated for unit testing.
+  Added PDCP support to the DPAA_SEC and DPAA2_SEC PMDs using rte_security
+  APIs.  Support has been added for all sequence number sizes for control and
+  user plane.  Test and test-crypto-perf applications have been updated for
+  unit testing.
 
 * **Updated the AESNI-MB PMD.**
 
@@ -230,7 +235,7 @@ New Features
 * **Updated the AESNI-GCM PMD.**
 
   * Added support for intel-ipsec-mb version 0.53.
-  * Supported in-place chained mbufs on AES-GCM algorithm.
+  * Added support for in-place chained mbufs with AES-GCM algorithm.
 
 * **Enabled Single Pass GCM acceleration on QAT GEN3.**
 
@@ -242,7 +247,8 @@ New Features
 * **Updated the Intel QuickAssist Technology (QAT) asymmetric crypto PMD.**
 
   * Added support for asymmetric session-less operations.
-  * Added support for RSA algorithm with pair (n, d) private key representation.
+  * Added support for RSA algorithm with pair ``(n, d)`` private key
+    representation.
   * Added support for RSA algorithm with quintuple private key representation.
 
 * **Updated the Intel QuickAssist Technology (QAT) compression PMD.**
@@ -252,19 +258,19 @@ New Features
 
 * **Added external buffers support for dpdk-test-compress-perf tool.**
 
-  Added a command line option to dpdk-test-compress-perf tool to allocate
-  and use memory zones as external buffers instead of keeping the data directly
-  in mbuf areas.
+  Added a command line option to the ``dpdk-test-compress-perf`` tool to
+  allocate and use memory zones as external buffers instead of keeping the
+  data directly in mbuf areas.
 
 * **Updated the IPSec library.**
 
-  * Added SA Database API to ``librte_ipsec``. A new test-sad application is also
-    introduced to evaluate and perform custom functional and performance tests
-    for IPsec SAD implementation.
+  * Added Security Associations (SA) Database API to ``librte_ipsec``. A new
+    test-sad application has also been introduced to evaluate and perform
+    custom functional and performance tests for an IPsec SAD implementation.
 
   * Support fragmented packets in inline crypto processing mode with fallback
-    ``lookaside-none`` session. Corresponding changes are also added in IPsec
-    Security Gateway application.
+    ``lookaside-none`` session. Corresponding changes are also added in the
+    IPsec Security Gateway application.
 
 * **Introduced FIFO for NTB PMD.**
 
@@ -278,20 +284,21 @@ New Features
 
 * **Added RIB and FIB (Routing/Forwarding Information Base) libraries.**
 
-  RIB and FIB can replace the LPM (Longest Prefix Match) library
-  with better control plane (RIB) performance.
-  The data plane (FIB) can be extended with new algorithms.
+  Added Routing and Forwarding Information Base (RIB/FIB) libraries. RIB and
+  FIB can replace the LPM (Longest Prefix Match) library with better control
+  plane (RIB) performance. The data plane (FIB) can be extended with new
+  algorithms.
 
-* **Updated testpmd.**
+* **Updated testpmd with a command for ptypes.**
 
   * Added a console command to testpmd app, ``show port (port_id) ptypes`` which
     gives ability to print port supported ptypes in different protocol layers.
   * Packet type detection disabled by default for the supported PMDs.
 
-* **Added new example l2fwd-event application.**
+* **Added new l2fwd-event sample application.**
 
-  Added an example application `l2fwd-event` that adds event device support to
-  traditional l2fwd example. It demonstrates usage of poll and event mode IO
+  Added an example application ``l2fwd-event`` that adds event device support to
+  the traditional l2fwd example. It demonstrates usage of poll and event mode IO
   mechanism under a single application.
 
 * **Added build support for Link Time Optimization.**
@@ -299,20 +306,20 @@ New Features
   LTO is an optimization technique used by the compiler to perform whole
   program analysis and optimization at link time.  In order to do that
   compilers store their internal representation of the source code that
-  the linker uses at the final stage of compilation process.
+  the linker uses at the final stage of the compilation process.
 
   See :doc:`../prog_guide/lto` for more information:
 
 * **Added IOVA as VA support for KNI.**
 
-  * Added IOVA = VA support for KNI, KNI can operate in IOVA = VA mode when
-    `iova-mode=va` EAL option is passed to the application or when bus IOVA
+  * Added IOVA = VA support for KNI. KNI can operate in IOVA = VA mode when
+    ``iova-mode=va`` EAL option is passed to the application or when bus IOVA
     scheme is selected as RTE_IOVA_VA. This mode only works on Linux Kernel
-    versions above 4.9.0.
+    versions >= 4.9.0.
 
   * Due to IOVA to KVA address translations, based on the KNI use case there
     can be a performance impact. For mitigation, forcing IOVA to PA via EAL
-    "--iova-mode=pa" option can be used, IOVA_DC bus iommu scheme can also
+    ``--iova-mode=pa`` option can be used, IOVA_DC bus iommu scheme can also
     result in IOVA as PA.
 
 
@@ -333,8 +340,8 @@ Removed Items
     port config all crc-strip|scatter|rx-cksum|rx-timestamp|
                     hw-vlan|hw-vlan-filter|hw-vlan-strip|hw-vlan-extend on|off
 
-  The testpmd commands set that can be used instead
-  in order to enable or disable Rx offloading on all Rx queues of a port is::
+  The testpmd command set that can be used instead in order to enable or
+  disable Rx offloading on all Rx queues of a port is::
 
     port config <port_id> rx_offload crc_strip|scatter|
                                      ipv4_cksum|udp_cksum|tcp_cksum|timestamp|
@@ -430,20 +437,21 @@ API Changes
   If the intent is to iterate over ports, ``RTE_ETH_FOREACH_*`` macros
   are better port iterators.
 
-* ethdev: RTE_FLOW_ITEM_TYPE_META data endianness altered to host one.
+* ethdev: ``RTE_FLOW_ITEM_TYPE_META`` data endianness altered to host one.
   Due to the new dynamic metadata field in mbuf is host-endian either, there
-  is the minor compatibility issue for applications in case of 32-bit values
+  is a minor compatibility issue for applications in case of 32-bit values
   supported.
 
-* ethdev: the tx_metadata mbuf field is moved to dymanic one.
-  PKT_TX_METADATA flag is replaced with PKT_TX_DYNF_METADATA.
-  DEV_TX_OFFLOAD_MATCH_METADATA offload flag is removed, now metadata
+* ethdev: the tx_metadata mbuf field is moved to dynamic one.
+  ``PKT_TX_METADATA`` flag is replaced with ``PKT_TX_DYNF_METADATA``.
+  ``DEV_TX_OFFLOAD_MATCH_METADATA`` offload flag is removed, now metadata
   support in PMD is engaged on dynamic field registration.
 
 * event: The function ``rte_event_eth_tx_adapter_enqueue`` takes an additional
   input as ``flags``. Flag ``RTE_EVENT_ETH_TX_ADAPTER_ENQUEUE_SAME_DEST`` which
   has been introduced in this release is used when used when all the packets
-  enqueued in the tx adapter are destined for the same Ethernet port & Tx queue.
+  enqueued in the Tx adapter are destined for the same Ethernet port ans Tx
+  queue.
 
 * sched: The pipe nodes configuration parameters such as number of pipes,
   pipe queue sizes, pipe profiles, etc., are moved from port level structure
@@ -472,9 +480,9 @@ ABI Changes
   align the Ethernet header on receive and all known encapsulations
   preserve the alignment of the header.
 
-* security: The field ``replay_win_sz`` has been moved from ipsec library
+* security: The field ``replay_win_sz`` has been moved from the ipsec library
   based ``rte_ipsec_sa_prm`` structure to security library based structure
-  ``rte_security_ipsec_xform``, which specify the Anti replay window size
+  ``rte_security_ipsec_xform``, which specify the anti-replay window size
   to enable sequence replay attack handling.
 
 * ipsec: The field ``replay_win_sz`` has been removed from the structure